local function GetDifficulty(pn)
	if not GAMESTATE:IsHumanPlayer(pn) then
		return nil
	end;
	if GAMESTATE:IsCourseMode() then
		return GAMESTATE:GetCurrentTrail(pn):GetDifficulty()
	else
		return GAMESTATE:GetCurrentSteps(pn):GetDifficulty()
	end;
	return nil -- should not get down here
end;

local playerDifficulties = {
	PlayerNumber_P1 = GetDifficulty(PLAYER_1),
	PlayerNumber_P2 = GetDifficulty(PLAYER_2),
};

local t = Def.ActorFrame{
	-- main frame
	LoadActor( THEME:GetPathG("_shared","elements/RoundedCornerBox"), WideScale(SCREEN_CENTER_X*1.75,SCREEN_CENTER_X*1.6), 104, color("0,0,0,0.425") )..{
		InitCommand=cmd(xy,SCREEN_CENTER_X,SCREEN_CENTER_Y*1.0375);
		OffCommand=cmd(bouncebegin,0.625;zoomy,0);
	};

	Def.ActorFrame{
		InitCommand=cmd(y,SCREEN_CENTER_Y*1.575);

		-- p1 frames
		Def.ActorFrame{
			InitCommand=cmd(hide_if,not GAMESTATE:IsHumanPlayer(PLAYER_1););
			OffCommand=cmd(bouncebegin,0.6;addx,-SCREEN_CENTER_X);
			LoadActor( THEME:GetPathG("_shared","elements/RoundedCornerBox"), 256, 104, color("0.4,0.4,0.4,1") )..{
				Name="P1StatsFrame";
				InitCommand=cmd(x,THEME:GetMetric(Var "LoadingScreen", "GraphDisplayP1X"));
			};
			-- todo: diffuse as player difficulty
			LoadActor( THEME:GetPathG("_shared","elements/RoundedCornerBox"), 152, 24, PlayerColor(PLAYER_1) )..{
				Name="P1StepsFrame";
				InitCommand=cmd(xy,THEME:GetMetric(Var "LoadingScreen", "GraphDisplayP1X")-60,-48);
			};
		};

		-- p2 frames
		Def.ActorFrame{
			InitCommand=cmd(hide_if,not GAMESTATE:IsHumanPlayer(PLAYER_2););
			OffCommand=cmd(bouncebegin,0.6;addx,SCREEN_CENTER_X);
			LoadActor( THEME:GetPathG("_shared","elements/RoundedCornerBox"), 256, 104, color("0.4,0.4,0.4,1") )..{
				Name="P2StatsFrame";
				InitCommand=cmd(x,THEME:GetMetric(Var "LoadingScreen", "GraphDisplayP2X"));
			};
			-- todo: diffuse as player difficulty
			LoadActor( THEME:GetPathG("_shared","elements/RoundedCornerBox"), 152, 24, PlayerColor(PLAYER_2) )..{
				Name="P2StepsFrame";
				InitCommand=cmd(xy,THEME:GetMetric(Var "LoadingScreen", "GraphDisplayP2X")+60,-48);
			};
		};
	};
};

return t;