--[[
LifeMeterText: part 1 of 2 of the new NCRX life meter,
designed to be out of your way so you can focus more on what's important.

* It shows your current health as a percentage.
* At certain milestones, it will change colors and/or pop up from off-screen.
* At 100%, the notification will be the same, plus in part 2, a player-colored
light appears on the side of the screen.
* At 20%/Danger, that light turns red and starts flashing...

The questions are:
* Where do we place this thing?
* Do I implement the small +/- amount text too?
--]]
local Player = ...
assert(...)

-- determine a few things based on player here

local t = Def.ActorFrame{
	Font("mentone","24px")..{
		Text="Life";
		InitCommand=cmd(shadowlength,1;zoom,0.5;y,15);
		BeginCommand=function(self)
			self:horizalign( Center1PDependent((Player == PLAYER_1 and right or left), center) );
		end;
	};
	Font("mentone","24px")..{
		InitCommand=cmd(diffuse,PlayerColor(Player);shadowlength,1);
		OnCommand=function(self)
			if GAMESTATE:GetPlayMode() == 'PlayMode_Oni' then
				self:settext("100%"); -- haaaaaaaaaaack
			end;
		end;
		LifeChangedMessageCommand=function(self,params)
			if(params.Player == Player) then
				local life = params.LifeMeter:GetLife() * 100;
				self:settext( string.format("%d",life).."%");
			end;
		end;
		HealthStateChangedMessageCommand=function(self,params)
			if(params.PlayerNumber == Player) then
				-- params.HealthState
			end;
		end;
	};
};

return t;