local t = Def.ActorFrame{
	Def.Actor{
		Name="MasterOfPuppets";
		CodeMessageCommand=function(self,params)
			local player = ToEnumShortString(params.PlayerNumber);
			if params.Name == "Pause" then
				local pauseStatus = SCREENMAN:GetTopScreen():IsPaused();
				SCREENMAN:GetTopScreen():PauseGame(not pauseStatus);
				MESSAGEMAN:Broadcast("PauseStatusChanged",{OldStatus = pauseStatus, PlayerNumber = params.PlayerNumber});
			end;
		end;
	};

	Def.Quad{
		InitCommand=cmd(Center;FullScreen;diffuse,color("0,0,0,0"));
		PauseStatusChangedMessageCommand=function(self,params)
			local pauseStatus = SCREENMAN:GetTopScreen():IsPaused();
			self:stoptweening();
			self:linear(0.5);
			self:diffusealpha( pauseStatus and 0.625 or 0 );
		end;
	};

	-- old
	--[[
	Font("mentone","24px")..{
		InitCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;shadowlength,1;diffusetopedge,color("1,1,1,0.25"));
		PauseStatusChangedMessageCommand=function(self,params)
			self:diffuse( PlayerColor(params.PlayerNumber) );
			local pauseStatus = SCREENMAN:GetTopScreen():IsPaused();
			self:settext( pauseStatus and "PAUSED" or "" );
		end;
	};
	--]]

	-- salvaged from ncrx cvs:
	LoadActor("pdCreditsText","PAUSED")..{
		InitCommand=cmd(Center;visible,false);
		PauseStatusChangedMessageCommand=function(self,params)
			local pauseStatus = SCREENMAN:GetTopScreen():IsPaused();
			self:visible( pauseStatus );
		end;
	};

	LoadActor("SongPositionMeter");
};

for pn in ivalues(GAMESTATE:GetHumanPlayers()) do
	t[#t+1] = LoadActor("LifeMeterText",pn)..{
		InitCommand=function(self)
			self:x( Center1PDependent((pn == PLAYER_1 and SCREEN_WIDTH*0.05 or SCREEN_WIDTH*0.95),SCREEN_CENTER_X) );
			self:y(SCREEN_TOP-64);
		end;
		OnCommand=cmd(bounceend,0.75;y,SCREEN_TOP+32);
		OffCommand=function(self)
			self:bounceend(0.5);
			-- center1P and 1P only: go up
			-- not center1P: go left or right per player
			if PREFSMAN:GetPreference("Center1Player") and GAMESTATE:GetNumPlayersEnabled() == 1 then
				self:y(SCREEN_TOP+64);
			else
				local mul = pn == PLAYER_1 and -1 or 1
				self:addx((SCREEN_CENTER_X)*mul);
			end;
		end;
	};
end;

local rpEnabled = getenv("RumblePak")
-- lol
t[#t+1] = Def.Actor{
	JudgmentMessageCommand=function(self,param)
		if not param.TapNoteScore then return end;
		if param.HoldNoteScore then return end;
		if rpEnabled and param.TapNoteScore == 'TapNoteScore_Miss' then
			SCREENMAN:GetTopScreen():vibrate();
			self:sleep(0.5);
			self:queuemessage("Unrumble");
		end;
	end;
	UnrumbleMessageCommand=function(self)
		SCREENMAN:GetTopScreen():stopeffect();
	end;
};

return t;