-- this is what ends up in the bottom frame in course mode.
local t = Def.ActorFrame{
	InitCommand=cmd(xy,TriScale(SCREEN_WIDTH*0.225,SCREEN_WIDTH*0.264583,SCREEN_WIDTH*0.25),(SCREEN_CENTER_Y*1.4125));
	Def.CourseContentsList {
		MaxSongs = 30; -- any course with over 30 songs?? idk
		NumItemsToDraw = 3.15;
		SetCommand=function(self)
			self:finishtweening();
			self:SetFromGameState();
			self:setsize(268,180);
			self:SetCurrentAndDestinationItem(1);
			-- todo: only true if course has > 3 songs.
			-- xxx: allows weird setups to happen (Song 3, Song 1, Song 2)
			local course = GAMESTATE:GetCurrentCourse();
			if course:GetEstimatedNumStages() < 4 then
				self:SetLoop(false);
			else
				self:SetLoop(true);
				self:scrollthroughallitems();
			end;
		end;
		CurrentCourseChangedMessageCommand=function(self)
			local course = GAMESTATE:GetCurrentCourse();
			self:visible( course and true or false );
		end;
		CurrentTrailP1ChangedMessageCommand=cmd(playcommand,"Set");
		CurrentTrailP2ChangedMessageCommand=cmd(playcommand,"Set");

		Display = Def.ActorFrame{ 
			InitCommand=cmd(setsize,270,44);

			Def.TextBanner {
				InitCommand=cmd(x,-12;y,-2;Load,"TextBanner";SetFromString,"", "", "", "", "", "");
				SetSongCommand=function(self, params)
					if params.Song then
						self:SetFromSong( params.Song );
						self:diffuse( SONGMAN:GetSongColor(params.Song) );
					else
						self:SetFromString( "??????????", "??????????", "", "", "", "" );
						self:diffuse( color("#FFFFFF") );
					end
				end;
				OffCommand=cmd(linear,0.2;diffusealpha,0);
			};

			Font("mentone","24px")..{
				InitCommand=cmd(x,-132;y,-16;shadowlength,1;horizalign,left;zoom,0.4;);
				SetSongCommand=function(self, params) 
					self:settext(string.format("Song %i", params.Number)); 
				end;
				OffCommand=cmd(linear,0.2;diffusealpha,0);
			};
			Font("handelgothic","20px")..{
				Text="0";
				InitCommand=cmd(x,-114;y,3;skewx,-0.15;zoom,1;shadowlength,1;);
				SetSongCommand=function(self, params)
					if params.PlayerNumber ~= GAMESTATE:GetMasterPlayerNumber() then return end
					self:settext( params.Meter );
					self:diffuse( CourseDifficultyToColor(params.Difficulty) );
				end;
				OffCommand=cmd(linear,0.2;diffusealpha,0);
			}; 

			Def.Quad{
				Name="SongSplitter";
				InitCommand=cmd(y,20;diffusealpha,0.5;zoomto,265,2;ztest,true);
				OffCommand=cmd(linear,0.2;zoomx,0);
			};

			--[[
			LoadFont("Common","normal") .. {
				OnCommand=cmd(x,SCREEN_CENTER_X-192;y,SCREEN_CENTER_Y-230;horizalign,right;shadowlength,0);
				SetSongCommand=function(self, params) self:settext(params.Modifiers); end;
			};
			--]]
		};
	};
};

return t;