-- yes yes now it's not just for songs anymore :wot:
local artistSlideTime = 0.2;
local outSleepTime = 1.3;
local outZoomTime = 0.5;

local t = Def.ActorFrame{
	Font("mentone","24px")..{
		Name="GenreText";
		InitCommand=cmd(zoom,0.5;y,-16;maxwidth,490;shadowlength,0);
		OffCommand=cmd(sleep,outSleepTime;linear,outZoomTime;zoomy,0;zoomx,SCREEN_WIDTH);
	};
	Font("mentone","24px")..{
		Name="TitleText";
		InitCommand=cmd(zoom,0.85;maxwidth,300;shadowlength,0);
		OffCommand=cmd(sleep,outSleepTime;linear,outZoomTime;zoomy,0;zoomx,SCREEN_WIDTH);
	};
	Font("mentone","24px")..{
		Name="SubTitleText";
		InitCommand=cmd(zoom,0.5;y,14;maxwidth,490;shadowlength,0);
		OffCommand=cmd(sleep,outSleepTime;linear,outZoomTime;zoomy,0;zoomx,SCREEN_WIDTH);
	};
	Font("mentone","24px")..{
		Name="ArtistText";
		-- y: 28 with subtitle, 20 without
		InitCommand=cmd(zoom,0.65;y,20;maxwidth,392;shadowlength,0);
		OffCommand=cmd(sleep,outSleepTime;linear,outZoomTime;zoomy,0;zoomx,SCREEN_WIDTH);
	};
	SetCommand=function(self)
		local genreText  = self:GetChild('GenreText');
		local titleText  = self:GetChild('TitleText');
		local subtitleText = self:GetChild('SubTitleText');
		local artistText = self:GetChild('ArtistText');

		local song = GAMESTATE:GetCurrentSong();
		if not song then
			if GAMESTATE:IsCourseMode() then
				local course = GAMESTATE:GetCurrentCourse();
				if course then
					local numStages = course:GetEstimatedNumStages();
					genreText:settext("");
					titleText:settext(course:GetDisplayFullTitle());
					local stageText = "stage";
					if numStages ~= 1 then stageText = stageText .. "s"; end;
					artistText:settext(numStages.." "..stageText);
				else
					genreText:settext("");
					titleText:settext("");
					artistText:settext("");
				end;
			else
				genreText:settext("");
				titleText:settext("");
				subtitleText:settext("");
				artistText:settext("");
				return;
			end;
		end;

		--[[ "Mexi Mexican ANOTHER .SM" is just slightly wider than I'd like;
		in a case like that, there are two options:
		1) maxwidth it
		2) break it up
		For very long subtitles, you're going to want option #2 anyways.
		--]]
		-- hack: this is for proper width detection
		if not GAMESTATE:IsCourseMode() then
			titleText:settext( song:GetDisplayFullTitle() );
			local fullTitleWidth = titleText:GetWidth();

			if song:GetDisplaySubTitle() ~= "" then
				if (fullTitleWidth - 300) > 18 then
					-- use two lines
					titleText:settext( song:GetDisplayMainTitle() );
					titleText:stoptweening();
					titleText:zoom(0.7);
					titleText:maxwidth(300*1.21429);
					subtitleText:settext( song:GetDisplaySubTitle() );
					artistText:stoptweening();
					artistText:linear(artistSlideTime);
					artistText:y(28);
					-- cetaka is a cuntface hack:
					-- "properly documented", the "cetaka is a cuntface" hack is a
					-- hack to get around a specific simfile, which I forget the name
					-- of at this moment. anyways the point is the guy has a million
					-- periods/fullstops/dots/whatever the shit at the end and it looks
					-- like ARSE!!!!!! fuck. so we fix this. -
					local subt = string.find(subtitleText:GetText(), "for emily.....")
					if subt then
						subtitleText:settext( "for emily" );
					end;
				else
					-- use one line
					titleText:settext( song:GetDisplayFullTitle() );
					titleText:stoptweening();
					titleText:zoom(0.85);
					titleText:maxwidth(300);
					subtitleText:settext("");
					artistText:stoptweening();
					artistText:linear(artistSlideTime);
					artistText:y(20);
				end;

				-- lol song specific crap that requires subtitle stuff goes here
				if subtitleText:GetText() == "(REALLY FUCKING HARD)" then
					-- canonically "HELL SCAPER FOR NIMA (REALLY FUCKING HARD)",
					-- but this works for any song that has this subtitle.
					subtitleText:jitter(true);
				else
					subtitleText:jitter(false);
				end;
			else
				-- use one line
				titleText:settext( song:GetDisplayFullTitle() );
				titleText:zoom(0.85);
				titleText:maxwidth(300);
				subtitleText:settext("");
				artistText:stoptweening();
				artistText:linear(artistSlideTime);
				artistText:y(20);
			end;

			-- set artist
			artistText:settext( song:GetDisplayArtist() );

			-- set genre; if you don't have a genre, one will be provided for you.
			-- here is a one-liner:
			--local setGenre = (song:GetGenre() == "") and GetRandomGenre() or song:GetGenre();
			-- and with expanded functionality:
			local setGenre = song:GetGenre();
			if song:GetGenre() == "" then
				setGenre = GetRandomGenre();
				genreText:skewx(-0.2);
				genreText:diffusebottomedge( color("0.85,0.85,0.85,1") );
			else
				genreText:skewx(0);
				genreText:diffusebottomedge( color("1,1,1,1") );
			end;
			genreText:settext(setGenre);
		end;
	end;
	CurrentSongChangedMessageCommand=cmd(playcommand,"Set");
	CurrentCourseChangedMessageCommand=cmd(playcommand,"Set");
};

return t;