--[[
Steps-single: step stat display for a single Player.
a lot of this code should be moved out to other files when completed.
this is just the test phase.
--]]
local Player = ...;
assert(Player);

--[[ PaneDisplay and Radar Values ]]
local rv;

local radarCategoryValues = {
	{ Category = 'RadarCategory_TapsAndHolds', Text = THEME:GetString("RadarCategory","Taps"), Color = color("1,1,1,1") },
	{ Category = 'RadarCategory_Jumps', Text = THEME:GetString("RadarCategory","Jumps"), Color = color("1,1,1,1") },
	{ Category = 'RadarCategory_Holds', Text = THEME:GetString("RadarCategory","Holds"), Color = color("1,1,1,1") },
	{ Category = 'RadarCategory_Mines', Text = THEME:GetString("RadarCategory","Mines"), Color = color("1,1,1,1") },
	{ Category = 'RadarCategory_Hands', Text = THEME:GetString("RadarCategory","Hands"), Color = color("1,1,1,1") },
	{ Category = 'RadarCategory_Rolls', Text = THEME:GetString("RadarCategory","Rolls"), Color = color("1,1,1,1") },
	--[[--------------------------------------------------------------]]
	{ Category = 'RadarCategory_Stream', Text = THEME:GetString("RadarCategory","Stream"), Color = HSV(32,0.5,1) },
	{ Category = 'RadarCategory_Voltage', Text = THEME:GetString("RadarCategory","Voltage"), Color = HSV(64,0.25,1) },
	{ Category = 'RadarCategory_Air', Text = THEME:GetString("RadarCategory","Air"), Color = HSV(192,0.25,1) },
	{ Category = 'RadarCategory_Freeze', Text = THEME:GetString("RadarCategory","Freeze"), Color = HSV(212,0.35,0.9) },
	{ Category = 'RadarCategory_Chaos', Text = THEME:GetString("RadarCategory","Chaos"), Color = HSV(356,0.5,1) }
};
--------
local pdrv = Def.ActorFrame{
	Name="PaneDisplayRadarValues"; -- LarryNeversWalterBudzyn
};

local paneHolder = Def.ActorFrame{ Name="PaneHolder"; };
local textZoom = 0.6;
local lineSpacing = 24*textZoom;

for i=1,#radarCategoryValues do
	-- panes on left (1-6), groove on right (7-11)
	paneHolder[#paneHolder+1] = Font("mentone","24px")..{
		Name="Label"..i;
		Text=radarCategoryValues[i].Text;
		InitCommand=cmd(horizalign,left;zoom,textZoom;shadowlength,1;diffusecolor,radarCategoryValues[i].Color);
		BeginCommand=function(self)
			self:x( (i > 6) and 8 or -120 );
			local multi = (i > 6) and i-6 or i;
			self:y( lineSpacing*multi );
		end;
	};
	-- number
	paneHolder[#paneHolder+1] = Font("mentone","24px")..{
		Name="Value"..i;
		InitCommand=cmd(horizalign,left;zoom,textZoom;shadowlength,1);
		BeginCommand=function(self)
			self:x( (i > 6) and 72 or -56 );
			local multi = (i > 6) and i-6 or i;
			self:y( lineSpacing * multi );
		end;
		OnCommand=cmd(playcommand,"Set");
		SetCommand=function(self)
			self:diffusecolor(radarCategoryValues[i].Color);
			local song, steps;
			if GAMESTATE:IsCourseMode() then
				song = GAMESTATE:GetCurrentCourse();
				steps = GAMESTATE:GetCurrentTrail(Player);
			else
				song = GAMESTATE:GetCurrentSong();
				steps = GAMESTATE:GetCurrentSteps(Player);
			end;

			if song then
				if steps then
					rv = steps:GetRadarValues(Player);
					local rc = radarCategoryValues[i].Category;
					local val = rv:GetValue(rc);
					if rc == 'RadarCategory_Stream' or rc == 'RadarCategory_Voltage'
						or rc == 'RadarCategory_Air' or rc == 'RadarCategory_Freeze'
						or rc == 'RadarCategory_Chaos' then
						-- convert Stream/Voltage/Air/Freeze/Chaos to percent.
						val = val * 100;
						val = (val == 100.0000) and "100%" or string.format("%.2f%%", val);
					end;
					self:settext( val );
					if val == 0 or val == "0.00%" then
						self:diffusealpha(0.5);
					else
						self:diffusealpha(1);
					end;
				else
					self:settext( "error?" );
				end;
			else
				self:settext( "" );
			end;
		end;
		CurrentSongChangedMessageCommand=cmd(playcommand,"Set");
		CurrentCourseChangedMessageCommand=cmd(playcommand,"Set");

		CurrentStepsP1ChangedMessageCommand=function(self)
			if Player == PLAYER_1 then self:playcommand("Set"); end;
		end;
		CurrentTrailP1ChangedMessageCommand=function(self)
			if Player == PLAYER_1 then self:playcommand("Set"); end;
		end;
		CurrentStepsP2ChangedMessageCommand=function(self)
			if Player == PLAYER_2 then self:playcommand("Set"); end;
		end;
		CurrentTrailP2ChangedMessageCommand=function(self)
			if Player == PLAYER_2 then self:playcommand("Set"); end;
		end;
	};
end;

pdrv[#pdrv+1] = paneHolder;

--[[ /PaneDisplay and Radar Values ]]

--[[ Top 3 Scores ]]
--[[ /Top 3 Scores ]]

--[[ sm-ssc only sections ]]
if SSC then
--[[ BPMs and Stops ]]
--[[ /BPMs and Stops ]]
end;
--[[ /sm-ssc only sections ]]

local t = Def.ActorFrame{

	Def.Quad{
		InitCommand=cmd(y,-88;zoomto,SCREEN_CENTER_X*0.8,SCREEN_CENTER_Y*0.75;MaskSource);
	};
	Def.Quad{
		InitCommand=cmd(y,172;zoomto,SCREEN_CENTER_X*0.8,SCREEN_CENTER_Y*0.1;clearzbuffer,false;zwrite,true;blend,'BlendMode_NoEffect');
	};

	Def.ActorScroller{
		NumItemsToDraw = 2;
		SecondsPerItem = 7.5;
		TransformFunction = function( self, offset, itemIndex, numItems )
			-- REMEMBER TO EDIT THIS WHEN YOU WANT IT TO FUCKING SCROLL AGAIN
			-- also probably convert this to a dynamic actor scroller if you
			-- don't end up redoing this to have one item composed of multiple
			-- elements instead.
			self:y( offset-1 * 192 );
		end;
		InitCommand=cmd(SetLoop,true;MaskDest;y,SCREEN_CENTER_Y*0.85;);
		ScrollCommand=function(self)
			-- todo: only scroll if there is actually a change being made.
			local curSong = GAMESTATE:GetCurrentSong();
			if curSong then
				--self:scrollwithpadding(0.15,1);
			end;
		end;
		CurrentSongChangedMessageCommand=cmd(playcommand,"Scroll");
		CurrentCourseChangedMessageCommand=cmd(playcommand,"Scroll");

		children = {
			-- these should just be pluggable LoadActors.
			pdrv;
			LoadActor("infoElements/CDTitle");
			--[[
			if SSC() then
				-- things that require sm-ssc
			end;
			--]]
		};
	};
};

return t;
--[[ naket coder was here ]]
