local flashTime = 0.125; -- was 0.25

local t = Def.ActorFrame{
	-- SCREENMAN:GetTopScreen():GetGoToOptions()
	Def.Quad{
		InitCommand=cmd(FullScreen;diffuse,color("0,0,0,0"));
		OffCommand=function(self)
			if SCREENMAN:GetTopScreen():GetGoToOptions() then
				-- PlayerOptionsMain
				self:linear(2);
				self:diffusealpha(1);
				MESSAGEMAN:Broadcast("OntoPlayerOptionsMain");
			else
				-- StageInformation
				self:linear(2);
				self:diffusealpha(1);
				MESSAGEMAN:Broadcast("OntoTheNextGameplay");
			end;
		end;
	};

	Def.ActorFrame{
		Name="WheelElements";
		InitCommand=cmd(fov,90);

		--[[ wheel backing ]]
		Def.Quad{
			InitCommand=cmd(x,WideScale(SCREEN_CENTER_X*1.325,SCREEN_CENTER_X*1.2725,SCREEN_CENTER_X*1.25);CenterY;zoomto,0,SCREEN_HEIGHT;diffuse,color("0,0,0,0.5"));
			OnCommand=cmd(bounceend,0.325;zoomto,TriScale(360*0.75,SCREEN_CENTER_X*0.75,SCREEN_CENTER_X*0.7),SCREEN_HEIGHT);
			OffCommand=cmd(linear,1;zoomx,0;rotationx,-65);
		};
		--[[ wheel sides ]]
		Def.Quad{
			Name="WheelBorderLeft";
			InitCommand=cmd(x,WideScale(((SCREEN_CENTER_X*1.325)*0.675)+1,((SCREEN_CENTER_X*1.2725)*0.7)+1);CenterY;zoomto,3,0;diffuse,HSVA(48,0.5,1,0.5);diffusebottomedge,HSVA(42,0.325,1,1));
			OnCommand=cmd(bounceend,0.5;zoomto,3,SCREEN_HEIGHT-(41*2));
			OffCommand=cmd(linear,1;x,SCREEN_CENTER_X*1.2725;zoomy,0;rotationx,-65);
		};
		Def.Quad{
			Name="WheelBorderRight";
			InitCommand=cmd(x,WideScale(((SCREEN_CENTER_X*1.325)*1.325)-1,((SCREEN_CENTER_X*1.2725)*1.3)-1);CenterY;zoomto,3,0;diffuse,HSVA(48,0.5,1,0.5);diffusebottomedge,HSVA(42,0.325,1,1));
			OnCommand=cmd(bounceend,0.25;zoomto,3,SCREEN_HEIGHT-(41*2));
			OffCommand=cmd(linear,1;x,SCREEN_CENTER_X*1.2725;zoomy,0;rotationx,-65);
		};
	};

	--[[ info frame graphics (see ScreenSelectMusic overlay for more) ]]
	Def.ActorFrame{
		Name="InfoFrames";
		InitCommand=cmd(x,TriScale(SCREEN_WIDTH*0.224292,SCREEN_WIDTH*0.26375,SCREEN_WIDTH*0.25);fov,90);

		-- Song Info Frame
		LoadActor("_frame song")..{
			InitCommand=cmd(y,SCREEN_CENTER_Y*0.6);
			OffCommand=cmd(linear,0.5;rotationx,35;diffusealpha,0);
		};
		-- Player Info Frame
		LoadActor("_frame player")..{
			InitCommand=cmd(y,SCREEN_CENTER_Y*1.4125);
			OffCommand=cmd(linear,0.5;rotationx,-35;diffusealpha,0);
		};
	};
};

return t;