local t = Def.ActorFrame{
	-- song BG
	Def.Sprite{
		InitCommand=cmd(Center;diffuse,color("0,0,0,1"));
		OnCommand=function(self)
			if GAMESTATE:IsCourseMode() then
				-- courses don't have backgrounds...
				--self:Load( THEME:GetPathG("Common fallback","background") );
				local course = GAMESTATE:GetCurrentCourse();
				if course then
					local entry1 = course:GetCourseEntry(0);
					local Path;
					if entry1 then
						Path = entry1:GetSong():GetBackgroundPath() or THEME:GetPathG("Common fallback","background")
					else
						Path = THEME:GetPathG("Common fallback","background")
					end;
					self:Load(Path);
				end;
			else
				-- load from background
				local song = GAMESTATE:GetCurrentSong();
				if song then
					local Path = song:GetBackgroundPath();
					if not Path then Path = THEME:GetPathG("Common fallback","background"); end;
					self:Load( Path );
				end;
			end;

			-- stretch
			self:scale_or_crop_background();

			self:sleep(0.25);
			self:decelerate(1);
			self:diffuse( color("1,1,1,1") )
		end;
		OffCommand=function(self)
			-- fade to the user's preferred brightness:
			local prefBrightness = PREFSMAN:GetPreference('BGBrightness');
			local diff = 1.0 - prefBrightness;
			self:accelerate(1.5);
			self:diffuse( color("1,1,1,".. diff) )
		end;
	};
};

return t;