local gapSize = 5;
local cloudTex = "_clouds";

local bg = Def.ActorFrame{
	--LoadActor( THEME:GetPathB("ScreenWithMenuElements","background") );
	Def.Quad{
		InitCommand=cmd(FullScreen;diffuse,color("#000000"));
		OnCommand=cmd(linear,0.7;diffusealpha,0);
	};
	-- test BG, kept here for posterity.
	--[[
	Def.Quad{
		InitCommand=cmd(FullScreen;diffuse,color("#000000"));
		--OnCommand=cmd(linear,0.25;diffuse,color("#002288");diffusetopedge,color("#0066CC"));
		OnCommand=function(self)

			local colors = {
				color("#880000"),
				color("#778800"),
				color("#000088"),
				color("#888800"),
				color("#880088"),
				color("#008888"),
			};

			local randIdx = math.random(#colors);

			--self:diffuse( colors[math.random(#colors)] );
			self:diffusealpha(0.8);
			self:accelerate(10);
			self:diffuse( colors[randIdx] );
			self:queuecommand("On");
		end;

		OffCommand=cmd(accelerate,1.5;diffuse,color("0,0,0,1"));
		TitleMenuOffMessageCommand=function(self,params)
			local c = params.Color;
			self:linear(0.5);
			self:diffuse( c );
		end;
	};
	--]]

	-- bottom clouds (scrolling down now)
	-- texcoordvelocity,-0.2,0;blend,'BlendMode_Add';
	LoadActor(cloudTex)..{
		InitCommand=cmd(Center;glow,color("1,1,1,0.1");diffusealpha,0.1);
		OnCommand=cmd(texcoordvelocity,0,-0.125;customtexturerect,0,0,2,1;zoomx,2;zoomy,1.05;wag;effectmagnitude,0,0,5;effectperiod,10;linear,0.5;diffusealpha,0.4;);
	};

	-- texcoordvelocity,0.295,0;blend,'BlendMode_Add';
	LoadActor(cloudTex)..{
		InitCommand=cmd(Center;diffusealpha,0.5;rotationy,90);
		OnCommand=cmd(texcoordvelocity,0,0.295;customtexturerect,0,0,2,1;zoomx,2;zoomy,1.05;linear,0.5;diffusealpha,0.3);
	};

	-- top clouds
	-- texcoordvelocity,-0.5,0;blend,'BlendMode_Add';
	LoadActor(cloudTex)..{
		InitCommand=cmd(Center;rotationy,40;diffusealpha,0.075;glow,color("1,1,1,0.05"));
		OnCommand=cmd(texcoordvelocity,0,0.2;customtexturerect,0,0,2,1;zoomx,2;zoomy,1.05;linear,0.5;diffusealpha,0.25);
	};

	-- top
	Def.Quad{
		-- 139px tall / SCREEN_CENTER_Y*0.579167
		-- SCREEN_CENTER_Y-99
		InitCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_TOP;vertalign,top;zoomx,SCREEN_WIDTH;diffuse,color("0,0,0,0.75");zoomy,0);
		OnCommand=cmd(diffusebottomedge,color("0.25,0.25,0.25,0.75");linear,0.3;zoomy,SCREEN_CENTER_Y-99-gapSize);
	};
	-- bot
	Def.Quad{
		-- 99 pixels tall at y = SCREEN_CENTER_Y*0.4125 (SCREEN_CENTER_Y-141) with 2 pixel gap.
		-- 99-2 = [97 + x = final with gap.]
		InitCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_BOTTOM;vertalign,bottom;zoomx,SCREEN_WIDTH;diffuse,color("0,0,0,0.75");zoomy,0);
		OnCommand=cmd(diffusetopedge,color("0.25,0.25,0.25,0.75");linear,0.3;zoomy,SCREEN_CENTER_Y-139-gapSize);
	};

	-- top gold
	Def.ActorFrame{
		Name="GoldTop";
		InitCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y-101);

		Def.Quad{
			InitCommand=cmd(diffuse,color("#FFCC00"));
			OnCommand=cmd(zoomto,0,5;linear,0.75;zoomto,SCREEN_WIDTH,5;);
			OffCommand=cmd(decelerate,1.25;zoomx,0);
		};

		Def.Quad{
			InitCommand=cmd(y,-1;diffuse,color("#FFCC00");blend,'BlendMode_Add';diffusealpha,0.35);
			OnCommand=cmd(zoomto,0,2;linear,0.75;zoomto,SCREEN_WIDTH,2;);
			OffCommand=cmd(decelerate,1.25;zoomx,0);
		};
	};

	-- bot gold
	Def.ActorFrame{
		Name="GoldBot";
		InitCommand=cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y+143);

		Def.Quad{
			InitCommand=cmd(diffuse,color("#FFCC00"));
			OnCommand=cmd(zoomto,0,5;linear,0.725;zoomto,SCREEN_WIDTH,5;);
			OffCommand=cmd(decelerate,1.25;zoomx,0);
		};

		Def.Quad{
			InitCommand=cmd(y,-1;diffuse,color("#FFCC00");blend,'BlendMode_Add';diffusealpha,0.35);
			OnCommand=cmd(zoomto,0,2;linear,0.725;zoomto,SCREEN_WIDTH,2;);
			OffCommand=cmd(decelerate,1.25;zoomx,0);
		};
	};
};

return bg;