local c;
local player = Var "Player";

local JudgeCmds = {
	TapNoteScore_W1 = THEME:GetMetric( "Judgment", "JudgmentW1Command" );
	TapNoteScore_W2 = THEME:GetMetric( "Judgment", "JudgmentW2Command" );
	TapNoteScore_W3 = THEME:GetMetric( "Judgment", "JudgmentW3Command" );
	TapNoteScore_W4 = THEME:GetMetric( "Judgment", "JudgmentW4Command" );
	TapNoteScore_W5 = THEME:GetMetric( "Judgment", "JudgmentW5Command" );
	TapNoteScore_Miss = THEME:GetMetric( "Judgment", "JudgmentMissCommand" );
};

local TNSFrames = {
	TapNoteScore_W1 = 0;
	TapNoteScore_W2 = 1;
	TapNoteScore_W3 = 2;
	TapNoteScore_W4 = 3;
	TapNoteScore_W5 = 4;
	TapNoteScore_Miss = 5;
};

local t = Def.ActorFrame {
	InitCommand=cmd(fov,90);
	
	LoadActor( "judgment" ) .. {
		Name="Judgment";
		InitCommand=cmd(pause;visible,false;);
		ResetCommand=cmd(finishtweening;x,0;y,0;stopeffect;visible,false);
	};
	InitCommand = function(self)
		c = self:GetChildren();
	end;

	JudgmentMessageCommand=function(self, param)
		if param.Player ~= player then return end;
		if not param.TapNoteScore then return end;
		if param.HoldNoteScore then return end; -- eat shit stepmania!!!

		-- frame check; actually relevant now.
		local iNumStates = c.Judgment:GetNumStates();
		local iFrame = TNSFrames[param.TapNoteScore];
		if not iFrame then return end
		if iNumStates == 12 then
			iFrame = iFrame * 2;
			if not param.Early then
				iFrame = iFrame + 1;
			end
		end
		self:playcommand("Reset");

		-- begin commands
		c.Judgment:visible( true );
		c.Judgment:setstate( iFrame );

		local iOffset = param.TapNoteOffset;
		if iFrame == 0 and iOffset then
			-- 0.00 = godlike
			if iOffset == 0.000 then
				c.Judgment:glowshift();
				c.Judgment:effectcolor1( color("1,0.8,0,0") );
				c.Judgment:effectcolor2( color("1,0.8,0,0.35") );
				c.Judgment:effectperiod( 0.01 );
			-- between -0.01 and 0.01 = radical
			elseif ( iOffset > -0.01 and iOffset < 0.01 ) and iOffset ~= 0.000 then
				c.Judgment:glowshift();
				c.Judgment:effectcolor1( color("1,1,1,0") );
				c.Judgment:effectcolor2( color("1,1,1,0.35") );
				c.Judgment:effectperiod( 0.01 );
			end;
		end;

		c.Judgment:diffusealpha(1);
		c.Judgment:zoom(1.3);
		c.Judgment:accelerate(0.125);
		c.Judgment:zoom(1.0);
		(cmd(sleep,0.8;linear,0.1;diffusealpha,0))(c.Judgment);
		--JudgeCmds[param.TapNoteScore](c.Judgment);
	end;
};

return t;
