local c;

local t = Def.ActorFrame{
	InitCommand=function(self)
		c = self:GetChildren();
	end;
};
if SSC then
	local stGraphics = {
		-- dance (ok)
		StepsType_Dance_Single = "_dance-single",
		StepsType_Dance_Double = "_dance-double",
		StepsType_Dance_Couple = "_dance-double",
		StepsType_Dance_Solo = "_solo",
		StepsType_Dance_Routine = "_dance-double",
		StepsType_Dance_Threepanel = "_dance-three",
		-- pump (ok)
		StepsType_Pump_Single = "_pump-single",
		StepsType_Pump_Halfdouble = "_pump-halfdouble",
		StepsType_Pump_Double = "_pump-double",
		StepsType_Pump_Couple = "_pump-double",
		StepsType_Pump_Routine = "_pump-double",
		-- kb7
		StepsType_Kb7_Single = "_kb7",
		-- ez2
		StepsType_Ez2_Single = "_base",
		StepsType_Ez2_Double = "_base",
		StepsType_Ez2_Real = "_base",
		-- para (ok)
		StepsType_Para_Single = "_generic5",
		-- ds3dx
		StepsType_Ds3ddx_Single = "_base",
		-- beat (ok)
		StepsType_Bm_Single5 = "_beat5",
		StepsType_Bm_Double5 = "_beat10",
		StepsType_Bm_Single7 = "_beat7",
		StepsType_Bm_Double7 = "_beat14",
		-- maniax
		StepsType_Maniax_Single = "_base",
		StepsType_Maniax_Double = "_base",
		-- techno (ok)
		StepsType_Techno_Single4 = "_dance-single",
		StepsType_Techno_Single5 = "_pump-single",
		StepsType_Techno_Single8 = "_techno8",
		StepsType_Techno_Double4 = "_dance-double",
		StepsType_Techno_Double5 = "_pump-double",
		-- popn (ok)
		StepsType_Pnm_Five = "_generic5",
		StepsType_Pnm_Nine = "_popn9",
		-- gametypes that don't matter
		StepsType_Guitar_Five = "_base", -- not implemented yet
		StepsType_Karaoke = "_base", -- not implemented yet
		StepsType_Lights_Cabinet = "_base", -- nobody plays this mode
	};

	for _, st in pairs(StepsType) do
		t[#t+1] = LoadActor( THEME:GetPathG("","_stepstype/"..stGraphics[st]) )..{
			Name=st;
			InitCommand=cmd(visible,false);
			ShowCommand=cmd(visible,true);
			HideCommand=cmd(visible,false);
		};
	end

	t.SetMessageCommand=function(self,param)
		for k, v in pairs(c) do
			c[k]:playcommand(c[k]:GetName() == param.StepsType and "Show" or "Hide");
			if param.Steps and param.Steps:IsAutogen() then
				(cmd(glowshift;effectperiod,0.5;effectcolor1,HSVA(48,0.5,1,0);effectcolor2,HSVA(48,1,1,0.25)))(c[k]);
			else
				(cmd(stopeffect))(c[k]);
			end;
		end;
	end;
end; -- if SSC

return t;